--- boost/python/detail/config.hpp~	2004-09-26 22:20:13.000000000 +0200
+++ boost/python/detail/config.hpp	2004-09-26 22:19:55.000000000 +0200
@@ -104,6 +104,9 @@
 // Replace broken Tru64/cxx offsetof macro
 # define BOOST_PYTHON_OFFSETOF(s_name, s_member) \
         ((size_t)__INTADDR__(&(((s_name *)0)->s_member)))
+#elif defined (__DragonFly__) && defined(__GNUC__) && __GNUC__ > 2
+#define BOOST_PYTHON_OFFSETOF(s_name, s_member) \
+       (__offsetof__ (reinterpret_cast <size_t> (&reinterpret_cast <const volatile char &> (static_cast<s_name *> (0)->s_member))))
 #else
 # define BOOST_PYTHON_OFFSETOF offsetof
 #endif
